#include <stdint.h>

typedef int (*uECC_RNG_Function)(uint8_t *p_dest, unsigned p_size);
void uECC_set_rng(uECC_RNG_Function p_rng);
int uECC_make_key(uint8_t p_publicKey[20*2], uint8_t p_privateKey[20]);
int uECC_shared_secret(const uint8_t p_publicKey[20*2], const uint8_t p_privateKey[20], uint8_t p_secret[20]);
void uECC_compress(const uint8_t p_publicKey[20*2], uint8_t p_compressed[20 +1]);
void uECC_decompress(const uint8_t p_compressed[20 +1], uint8_t p_publicKey[20*2]);
int uECC_sign(const uint8_t p_privateKey[20], const uint8_t p_hash[20], uint8_t p_signature[20*2]);
int uECC_verify(const uint8_t p_publicKey[20*2], const uint8_t p_hash[20], const uint8_t p_signature[20*2]);
int uECC_bytes();
int uECC_curve();
